//
//  CPUUsageIconMaker.m
//  CPU Usage Icon Maker
//
//  Created by Peter Hosey on 2006-06-23.
//  Copyright 2006 Peter Hosey. All rights reserved.
//

#import "CPUUsageIconMaker.h"

#import "CPUUsageView.h"

@implementation CPUUsageIconMaker

- (void)applicationDidFinishLaunching:(NSNotification *)notification {
	NSOpenPanel *openPanel = [NSOpenPanel openPanel];
	[openPanel setCanChooseDirectories:YES];
	[openPanel setCanChooseFiles:NO];

	[self openPanelDidEnd:openPanel returnCode:[openPanel runModalForDirectory:nil file:nil] contextInfo:NULL];
}

- (void)openPanelDidEnd:(NSOpenPanel *)openPanel returnCode:(int)returnCode contextInfo:(void *)contextInfo {
	NSLog(@"callback called. return code is %i; OK is %i; Cancel is %i", returnCode, NSOKButton, NSCancelButton);

	if(returnCode == NSOKButton) {
		if(![[NSFileManager defaultManager] changeCurrentDirectoryPath:[openPanel filename]]) {
			NSDictionary *errorDict = [NSDictionary dictionaryWithObjectsAndKeys:
				NSLocalizedString(@"Cannot write icon files", /*comment*/ nil), NSLocalizedDescriptionKey,
				NSLocalizedString(@"Could not change working directory", /*comment*/ nil), NSLocalizedFailureReasonErrorKey,
				nil];
			[NSApp presentError:[NSError errorWithDomain:@"Completely made-up domain" code:1 userInfo:errorDict]];
		}

		NSRect frame = { NSZeroPoint, { 128.0f, 128.0f } };
		CPUUsageView *view = [[CPUUsageView alloc] initWithFrame:frame];
		[view setDrawsFrame:YES];
		[view setCPUUsage:0.63f];

		NSImage *image = [[NSImage alloc] initWithSize:frame.size];
		[image lockFocus];
		[view drawRect:frame];
		[image unlockFocus];
		NSLog(@"Wrote 128pt icon: %hhi", [[image TIFFRepresentation] writeToFile:@"CPUUsageIcon-128.tiff" atomically:NO]);
		[image release];

		frame.size.width = frame.size.height = 48.0f;
		[view setFrame:frame];
		image = [[NSImage alloc] initWithSize:frame.size];
		[image lockFocus];
		[view drawRect:frame];
		[image unlockFocus];
		NSLog(@"Wrote 48pt icon: %hhi", [[image TIFFRepresentation] writeToFile:@"CPUUsageIcon-48.tiff" atomically:NO]);
		[image release];

		frame.size.width = frame.size.height = 32.0f;
		[view setFrame:frame];
		image = [[NSImage alloc] initWithSize:frame.size];
		[image lockFocus];
		[view drawRect:frame];
		[image unlockFocus];
		NSLog(@"Wrote 32pt icon: %hhi", [[image TIFFRepresentation] writeToFile:@"CPUUsageIcon-32.tiff" atomically:NO]);
		[image release];

		frame.size.width = frame.size.height = 16.0f;
		[view setFrame:frame];
		image = [[NSImage alloc] initWithSize:frame.size];
		[image lockFocus];
		[view drawRect:frame];
		[image unlockFocus];
		NSLog(@"Wrote 16pt icon: %hhi", [[image TIFFRepresentation] writeToFile:@"CPUUsageIcon-16.tiff" atomically:NO]);
		[image release];

		[view release];
	}

	[NSApp terminate:nil];
}

@end
